namespace Warship
{
    public partial class FormWarship : Form
    {
        private DrawingWarship _warship;

        public DrawingWarship SelectedWarship { get; private set; }
        public FormWarship()
        {
            InitializeComponent();
        }
        private void Draw()
        {
            Bitmap bmp = new(pictureBoxWarship.Width, pictureBoxWarship.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _warship?.DrawTransport(gr);
            pictureBoxWarship.Image = bmp;
        }

        private void SetData()
        {
            Random rnd = new();
            _warship.SetPosition(rnd.Next(10, 100), rnd.Next(10, 100), pictureBoxWarship.Width, pictureBoxWarship.Height);
            toolStripStatusLabelSpeed.Text = $"C: {_warship.Warship.Speed}";
            toolStripStatusLabelWeight.Text = $": {_warship.Warship.Weight}";
            toolStripStatusLabelBodyColor.Text = $": {_warship.Warship.BodyColor.Name}";
        }

        private void ButtonCreate_Click(object sender, EventArgs e)
        {
            Random rnd = new();
            _warship = new DrawingWarship(rnd.Next(10, 60), rnd.Next(20000, 25000), Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256)));
            SetData();
            Draw();
        }
        private void ButtonMove_Click(object sender, EventArgs e)
        {
            string name = ((Button)sender)?.Name ?? string.Empty;
            switch (name)
            {
                case "buttonUp":
                    _warship?.MoveTransport(Direction.Up);
                    break;
                case "buttonDown":
                    _warship?.MoveTransport(Direction.Down);
                    break;
                case "buttonLeft":
                    _warship?.MoveTransport(Direction.Left);
                    break;
                case "buttonRight":
                    _warship?.MoveTransport(Direction.Right);
                    break;
            }
            Draw();
        }

        private void PictureBoxWarship_Resize(object sender, EventArgs e)
        {
            _warship?.ChangeBorders(pictureBoxWarship.Width, pictureBoxWarship.Height);
            Draw();
        }

        private void ButtonCreateModif_Click(object sender, EventArgs e)
        {
            Random rnd = new();
            _warship = new DrawingAdvancedWarship(rnd.Next(10, 60), rnd.Next(20000, 25000), Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256)), Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256)), Convert.ToBoolean(rnd.Next(0,2)), Convert.ToBoolean(rnd.Next(0, 2)), Convert.ToBoolean(rnd.Next(0, 2)));
            SetData();
            Draw();
        }

        private void ButtonSelect_Click(object sender, EventArgs e)
        {
            SelectedWarship = _warship;
            DialogResult = DialogResult.OK;
        }
    }
}