﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Warship
{
    internal class SetWarshipsGeneric<T>
        where T : class
    {
        private readonly T[] _places;

        public int Count => _places.Length;

        public SetWarshipsGeneric(int count)
        {
            _places = new T[count];
        }

        public bool Insert(T warship)
        {
            _places[0] = warship;
            return true;
        }
        
        public bool Insert(T warship, int position)
        {
            int EmptyEl=position;

            if (_places[position]!=null)
            {
                for (int i = position; i < Count; i++)
                    if (_places[i] == null)
                    {
                        EmptyEl = i;
                        break;
                    }
                for (int j = EmptyEl; j > position; j--)
                    _places[j] = _places[j - 1];
            }

            _places[position] = warship;
            return true;
        }

        public bool Remove(int position)
        {
            _places[position] = null;
            return true;
        }

        public T Get(int position)
        {
            return _places[position];
        }
    }
}
