﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Warship
{
    internal class SimpleMap : AbstractMap
    {
        private readonly Brush waterColor = new SolidBrush(Color.Blue);
        private readonly Brush landColor = new SolidBrush(Color.Brown);
        protected override void DrawLandPart(Graphics gr, int i, int j)
        {
            gr.FillRectangle(landColor, i * _size_x, j * _size_y, i * (_size_x + 1), j * (_size_y + 1));
        }

        protected override void DrawWaterPart(Graphics gr, int i, int j)
        {
            gr.FillRectangle(waterColor, i * _size_x, j * _size_y, i * (_size_x + 1), j * (_size_y + 1));
        }

        protected override void GenerateMap()
        {
            _map = new int[100, 100];
            _size_x = (float)_width / _map.GetLength(0);
            _size_y=(float)_height / _map.GetLength(1);
            int counter = 0;
            for (int i=0;i<_map.GetLength(0); ++i)
            {
                for (int j = 0; j < _map.GetLength(1); ++j)
                {
                    _map[i, j] = _freeWaterArea;
                }
            }
            while (counter < 50)
            {
                int x = _random.Next(0, 100);
                int y = _random.Next(0, 100);
                if (_map[x, y] == _freeWaterArea)
                {
                    _map[x, y] = _land;
                    counter++;
                }
            }
        }
    }
}
